(function (global, factory) {
  if (typeof define === "function" && define.amd) {
    define(['exports', 'react', 'd3'], factory);
  } else if (typeof exports !== "undefined") {
    factory(exports, require('react'), require('d3'));
  } else {
    var mod = {
      exports: {}
    };
    factory(mod.exports, global.react, global.d3);
    global.dndTree = mod.exports;
  }
})(this, function (exports, _react, _d) {
  'use strict';

  Object.defineProperty(exports, "__esModule", {
    value: true
  });

  var _react2 = _interopRequireDefault(_react);

  var d3 = _interopRequireWildcard(_d);

  function _interopRequireWildcard(obj) {
    if (obj && obj.__esModule) {
      return obj;
    } else {
      var newObj = {};

      if (obj != null) {
        for (var key in obj) {
          if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key];
        }
      }

      newObj.default = obj;
      return newObj;
    }
  }

  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
      default: obj
    };
  }

  function _classCallCheck(instance, Constructor) {
    if (!(instance instanceof Constructor)) {
      throw new TypeError("Cannot call a class as a function");
    }
  }

  var _createClass = function () {
    function defineProperties(target, props) {
      for (var i = 0; i < props.length; i++) {
        var descriptor = props[i];
        descriptor.enumerable = descriptor.enumerable || false;
        descriptor.configurable = true;
        if ("value" in descriptor) descriptor.writable = true;
        Object.defineProperty(target, descriptor.key, descriptor);
      }
    }

    return function (Constructor, protoProps, staticProps) {
      if (protoProps) defineProperties(Constructor.prototype, protoProps);
      if (staticProps) defineProperties(Constructor, staticProps);
      return Constructor;
    };
  }();

  function _possibleConstructorReturn(self, call) {
    if (!self) {
      throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
    }

    return call && (typeof call === "object" || typeof call === "function") ? call : self;
  }

  function _inherits(subClass, superClass) {
    if (typeof superClass !== "function" && superClass !== null) {
      throw new TypeError("Super expression must either be null or a function, not " + typeof superClass);
    }

    subClass.prototype = Object.create(superClass && superClass.prototype, {
      constructor: {
        value: subClass,
        enumerable: false,
        writable: true,
        configurable: true
      }
    });
    if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass;
  }

  var DndTree = function (_React$Component) {
    _inherits(DndTree, _React$Component);

    function DndTree(props) {
      _classCallCheck(this, DndTree);

      var _this = _possibleConstructorReturn(this, (DndTree.__proto__ || Object.getPrototypeOf(DndTree)).call(this, props));

      _this.state = {};
      return _this;
    }

    _createClass(DndTree, [{
      key: 'componentDidMount',
      value: function componentDidMount() {
        var height, width, svg, g, tree, stratify;

        height = +this.props.height;
        width = +this.props.width;

        svg = d3.select(".dndTree").attr('height', height).attr('width', width);

        g = svg.append("g").attr("transform", "translate(40,0)");

        tree = d3.cluster().size([height, width - 160]);

        stratify = d3.stratify().parentId(function (d) {
          return d.id.substring(0, d.id.lastIndexOf("."));
        });

        function makeTree(data) {
          console.log('data inside of tree', data);
          var root, treeRoot, link, node;

          root = stratify(data).sort(function (a, b) {
            return a.height - b.height || a.id.localeCompare(b.id);
          });

          tree(root);

          link = g.selectAll(".link").data(root.descendants().slice(1)).enter().append("path").attr("class", "link").attr('fill', 'none').attr("d", function (d) {
            return "M" + d.y + "," + d.x + "C" + (d.parent.y + 100) + "," + d.x + " " + (d.parent.y + 100) + "," + d.parent.x + " " + d.parent.y + "," + d.parent.x;
          }).style('fill', 'none').style('stroke', '#555').style('stroke-opacity', '0.4').style('stroke-width', '1.5px');

          node = g.selectAll(".node").data(root.descendants()).enter().append("g").attr("class", function (d) {
            return "node" + (d.children ? " node--internal" : " node--leaf");
          }).attr("transform", function (d) {
            return "translate(" + d.y + "," + d.x + ")";
          });

          node.append("circle").attr("r", 2.5).style('fill', '#999');

          node.append("text").attr("dy", 3).attr("x", function (d) {
            return d.children ? -8 : 8;
          }).style("text-anchor", function (d) {
            return d.children ? "end" : "start";
          }).text(function (d) {
            return d.id.substring(d.id.lastIndexOf(".") + 1);
          }).style('font', '10px sans-serif');

          // adding styles here  
          d3.selectAll('.node--internal circle').style('fill', '#555');

          d3.selectAll('.node--internal text').style('text-shadow', '0 1px 0 #fff');
        };

        return makeTree(this.props.data);
      }
    }, {
      key: 'render',
      value: function render() {
        return _react2.default.createElement(
          'div',
          null,
          _react2.default.createElement('svg', { className: 'DndTree' })
        );
      }
    }]);

    return DndTree;
  }(_react2.default.Component);

  exports.default = DndTree;


  DndTree.propTypes = {
    height: _react2.default.PropTypes.number.isRequired,
    width: _react2.default.PropTypes.number.isRequired,
    data: _react2.default.PropTypes.array.isRequired
  };
});