(function (global, factory) {
  if (typeof define === "function" && define.amd) {
    define(['exports', './barchart/stackedgroupedbar.jsx', './CirclePacking/CirclePacking.jsx', './dnd-tree/dndTree.jsx', './hierarchical/hierarchical.jsx', './pie/pie.jsx', './scatterPlot/scatterPlot.jsx', './sunburst/sunburst.jsx', './sunburst/sequence.jsx', './voronoi/voronoi.jsx', './zoomableMap/zoomableMap.jsx', './zoomableMap/zoomableCountiesMap.jsx'], factory);
  } else if (typeof exports !== "undefined") {
    factory(exports, require('./barchart/stackedgroupedbar.jsx'), require('./CirclePacking/CirclePacking.jsx'), require('./dnd-tree/dndTree.jsx'), require('./hierarchical/hierarchical.jsx'), require('./pie/pie.jsx'), require('./scatterPlot/scatterPlot.jsx'), require('./sunburst/sunburst.jsx'), require('./sunburst/sequence.jsx'), require('./voronoi/voronoi.jsx'), require('./zoomableMap/zoomableMap.jsx'), require('./zoomableMap/zoomableCountiesMap.jsx'));
  } else {
    var mod = {
      exports: {}
    };
    factory(mod.exports, global.stackedgroupedbar, global.CirclePacking, global.dndTree, global.hierarchical, global.pie, global.scatterPlot, global.sunburst, global.sequence, global.voronoi, global.zoomableMap, global.zoomableCountiesMap);
    global.indexEs = mod.exports;
  }
})(this, function (exports, _stackedgroupedbar, _CirclePacking, _dndTree, _hierarchical, _pie, _scatterPlot, _sunburst, _sequence, _voronoi, _zoomableMap, _zoomableCountiesMap) {
  'use strict';

  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  Object.defineProperty(exports, 'StackedGroupedBar', {
    enumerable: true,
    get: function () {
      return _stackedgroupedbar.StackedGroupedBar;
    }
  });
  Object.defineProperty(exports, 'CirclePacking', {
    enumerable: true,
    get: function () {
      return _CirclePacking.CirclePacking;
    }
  });
  Object.defineProperty(exports, 'DndTree', {
    enumerable: true,
    get: function () {
      return _dndTree.DndTree;
    }
  });
  Object.defineProperty(exports, 'HierarchicalEdgeBundle', {
    enumerable: true,
    get: function () {
      return _hierarchical.HierarchicalEdgeBundle;
    }
  });
  Object.defineProperty(exports, 'Pie', {
    enumerable: true,
    get: function () {
      return _pie.Pie;
    }
  });
  Object.defineProperty(exports, 'ScatterPlot', {
    enumerable: true,
    get: function () {
      return _scatterPlot.ScatterPlot;
    }
  });
  Object.defineProperty(exports, 'SunBurst', {
    enumerable: true,
    get: function () {
      return _sunburst.SunBurst;
    }
  });
  Object.defineProperty(exports, 'SequenceSunBurst', {
    enumerable: true,
    get: function () {
      return _sequence.SequenceSunBurst;
    }
  });
  Object.defineProperty(exports, 'Voronoi', {
    enumerable: true,
    get: function () {
      return _voronoi.Voronoi;
    }
  });
  Object.defineProperty(exports, 'ZoomableMap', {
    enumerable: true,
    get: function () {
      return _zoomableMap.ZoomableMap;
    }
  });
  Object.defineProperty(exports, 'ZoomableCountiesMap', {
    enumerable: true,
    get: function () {
      return _zoomableCountiesMap.ZoomableCountiesMap;
    }
  });
});