(function (global, factory) {
  if (typeof define === "function" && define.amd) {
    define(['exports', 'react', 'd3'], factory);
  } else if (typeof exports !== "undefined") {
    factory(exports, require('react'), require('d3'));
  } else {
    var mod = {
      exports: {}
    };
    factory(mod.exports, global.react, global.d3);
    global.pie = mod.exports;
  }
})(this, function (exports, _react, _d) {
  'use strict';

  Object.defineProperty(exports, "__esModule", {
    value: true
  });

  var _react2 = _interopRequireDefault(_react);

  var d3 = _interopRequireWildcard(_d);

  function _interopRequireWildcard(obj) {
    if (obj && obj.__esModule) {
      return obj;
    } else {
      var newObj = {};

      if (obj != null) {
        for (var key in obj) {
          if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key];
        }
      }

      newObj.default = obj;
      return newObj;
    }
  }

  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
      default: obj
    };
  }

  function _classCallCheck(instance, Constructor) {
    if (!(instance instanceof Constructor)) {
      throw new TypeError("Cannot call a class as a function");
    }
  }

  var _createClass = function () {
    function defineProperties(target, props) {
      for (var i = 0; i < props.length; i++) {
        var descriptor = props[i];
        descriptor.enumerable = descriptor.enumerable || false;
        descriptor.configurable = true;
        if ("value" in descriptor) descriptor.writable = true;
        Object.defineProperty(target, descriptor.key, descriptor);
      }
    }

    return function (Constructor, protoProps, staticProps) {
      if (protoProps) defineProperties(Constructor.prototype, protoProps);
      if (staticProps) defineProperties(Constructor, staticProps);
      return Constructor;
    };
  }();

  function _possibleConstructorReturn(self, call) {
    if (!self) {
      throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
    }

    return call && (typeof call === "object" || typeof call === "function") ? call : self;
  }

  function _inherits(subClass, superClass) {
    if (typeof superClass !== "function" && superClass !== null) {
      throw new TypeError("Super expression must either be null or a function, not " + typeof superClass);
    }

    subClass.prototype = Object.create(superClass && superClass.prototype, {
      constructor: {
        value: subClass,
        enumerable: false,
        writable: true,
        configurable: true
      }
    });
    if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass;
  }

  var Pie = function (_React$Component) {
    _inherits(Pie, _React$Component);

    function Pie(props) {
      _classCallCheck(this, Pie);

      return _possibleConstructorReturn(this, (Pie.__proto__ || Object.getPrototypeOf(Pie)).call(this, props));
    }

    _createClass(Pie, [{
      key: 'componentDidMount',
      value: function componentDidMount() {
        var context, width, height, data, group, count, radius, colors, arc, labelArc, pie, svg, g;

        width = this.props.width;
        height = this.props.height;

        group = this.props.group;
        count = this.props.count;
        data = this.props.data;

        radius = Math.min(width, height) / 2;
        colors = d3.scaleOrdinal(d3.schemeCategory20);

        arc = d3.arc().outerRadius(radius - 10).innerRadius(0);

        labelArc = d3.arc().outerRadius(radius - 40).innerRadius(radius - 40);

        pie = d3.pie().value(function (d) {
          return d[count];
        });

        svg = d3.select('#pie').append('svg').attr('width', width).attr('height', height).append('g').attr('transform', 'translate(' + width / 2 + ',' + height / 2 + ')');

        g = svg.selectAll('.arc').data(pie(data)).enter().append('g').attr('class', arc);

        g.append('path').attr('d', arc).style('fill', function (d) {
          return colors(d.data[group]);
        });

        g.append('text').attr('transform', function (d) {
          return 'translate(' + labelArc.centroid(d) + ')';
        }).attr("dy", ".35em").text(function (d) {
          return d.data[group];
        });
      }
    }, {
      key: 'render',
      value: function render() {
        return _react2.default.createElement('div', { id: 'pie' });
      }
    }]);

    return Pie;
  }(_react2.default.Component);

  Pie.propTypes = {
    width: _react2.default.PropTypes.number,
    height: _react2.default.PropTypes.number,
    data: _react2.default.PropTypes.array.isRequired,
    group: _react2.default.PropTypes.string.isRequired,
    count: _react2.default.PropTypes.string.isRequired
  };

  Pie.defaultProps = {
    width: 960,
    height: 500
  };

  exports.default = Pie;
});